<?php
/**
* @version		2.6.7
 * @package		Joomla
 * @subpackage	Documents Seller
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2018-2011 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
defined( '_JEXEC' ) or die ;

jimport( 'joomla.application.component.view');
/**
 * HTML View class for Documents Selelr component
 *
 * @static
 * @package		Joomla
 * @subpackage	Documents Seller
 * @since 1.5
 */
class DMSViewDocument extends JView
{
	function display($tpl = null)
	{	
	    $mainframe = & JFactory::getApplication() ;
	    if (version_compare(JVERSION, '1.6.0', 'ge')) {
	        $j15 = false ;
	    } else {
	        $j15 = true ;
	    }	    
		#Hardcode the layout to avoid error
		$this->setLayout('default') ;								
		$document = & JFactory::getDocument();	
		$db = & JFactory::getDBO();			
		$Itemid = JRequest::getInt('Itemid', 0) ;
		$id = JRequest::getInt('id', 0) ;
		if (!$id) {
			//Try to get the document id from menu item
			$menus = & JSite::getMenu();
			$menu = $menus->getActive();
			if (is_object($menu)) {
			    if ($j15) {
			        $params = new JParameter($menu->params) ;
			    } else {
			        $params = new JRegistry() ;
			        $params->loadString($menu->params) ;
			    }			    				
				$id = (int) $params->get('document_id', 0);
				if ($id) {
					JRequest::setVar('id', $id, 'get') ;
				}
			}
		}
		$sql = 'SELECT COUNT(*) FROM #__dms_documents WHERE id='.$id.' AND published= 1' ;
		$db->setQuery($sql) ;
		$totalDoc = $db->loadResult();
		if (!$totalDoc) {
			$mainframe->redirect('index.php?option=com_dms&Itemid='.$Itemid, JText::_('DMS_INVALID_DOCUMENT'));			
		} else {
			$sql = 'UPDATE #__dms_documents SET hits = hits + 1 WHERE id='.$id ;
			$db->setQuery($sql) ;
			$db->query();
		}
		jimport('joomla.filesystem.file') ;
		require_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_dms'.DS.'class'.DS.'DMS_file.class.php' ;		
		$config = DMSHelper::getConfig();				
		$pathway =& $mainframe->getPathway(); 										
		$item = & $this->get('Data');										
		$parents = & $this->get('categories');
		for ($i = count($parents)-1 ; $i >= 0 ; $i--) {
			$parent = $parents[$i] ;
			if ($parent->total_children)					
				$pathUrl = JRoute::_('index.php?option=com_dms&view=categories&category_id='.$parent->id.'&Itemid='.$Itemid);
			else 
				$pathUrl = JRoute::_('index.php?option=com_dms&view=category&category_id='.$parent->id.'&Itemid='.$Itemid);	
			$pathway->addItem($parent->name, $pathUrl);
		}		
		$pathway->addItem($item->title);
		$item->data = new DMS_File($item->filename, $config->documents_path) ;		
		$metaKey = $item->meta_key ;
		$metaDescription = $item->meta_description ;
		if ($metaKey) {
			$document->setMetaData('keywords', $metaKey);			
		}		
		if ($metaDescription) {
			$document->setMetaData('description', $metaDescription);
		}
		$document->setTitle($item->title);
		$arr = DMSHelper::getDownloadableDocs();
		$tmpl = JRequest::getVar('tmpl', '') ;		
		if ($config->process_plugin) {
		    if ($j15) {
		        $dispatcher = & JDispatcher::getInstance();
    			JPluginHelper::importPlugin('content');
    			$params = new JParameter('');
    			$limitstart = 0 ;			
    			$article = new stdClass ;
    			$article->catid = 0 ; 
    			$article->sectionid = 0;
    			$article->text = $item->description ;
    			$dispatcher->trigger('onPrepareContent', array (& $article, & $params, $limitstart));
    			$item->description = $article->text ;
		    } else {
		        $item->description = JHtml::_('content.prepare', $item->description);    
		    }			 						
		}				
		if ($tmpl == 'component')
			$showTaskBar = false ;
		else 
			$showTaskBar = true ;	    					
		$docs = $arr['docs'] ;			
		$user = & JFactory::getUser() ;
		$userId = $user->get('id', 0);
	    if (version_compare(JVERSION, '1.6.0', 'ge')) {
		   $viewLevels = $user->getAuthorisedViewLevels() ;
		   $this->assignRef('viewLevels', $viewLevels) ;
		} else {
		   $aid = $user->get('aid');
		   $this->assignRef('aid', $aid) ;
		}
		$this->assignRef('item', $item) ;															
		$this->assignRef('Itemid', $Itemid) ;
		$this->assignRef('config', $config) ;
		$this->assignRef('showTaskBar', $showTaskBar) ;			
		$this->assignRef('docs', $docs) ;	
		$this->assignRef('userId', $userId) ;			
		parent::display($tpl);										
	}					
}